<?php
class IMMTRADEIN_STOCK{
	/*Privilage description:
	DEFAULT		: VIEWABLE (checked by class IMMTRADEIN)
	VIEWABLE	: View stock
	EDITFRONTEND: N/A
	EDITBACKEND	: N/A
	SUPERUSER	: N/A
	*/
	
	public function __construct ($userprivilage,$appname)
	{
		$this->userprivilage=$userprivilage;
		$this->appname=$appname;
		$this->siteclass = new IMMINVENTORY_SITE($this->userprivilage,$this->appname);
	}
	
	public function getstocklist($distinct,$itemid,$siteid,$sni)
	{	/*get stock list
		all arguments are ignored. The follow descriptions are inherited from IMMINVENTORY_STOCK:
		if $distinct=TRUE,return a list of itemid with info that is in stocklist (ignored if $sni is not null)
		If $itemid and/or $site is null, WHERE clause will omit itemid and/or site selection
		Return false if error
		*/
		global $sqllink;
		
		/*formation of where clause
		$whereclause='';
		if($itemid !==null)
			$whereclause.=" itemid=$itemid";
		if($siteid !==null)
		{
			if (strlen($whereclause)!=0)
				$whereclause.=" AND";
			if ($siteid!==-1)
				$whereclause.=" f.site=$siteid";
			else
				$whereclause.=" g.warehouse=1";
		}
		if($sni !==null)
		{
			if (strlen($whereclause)!=0)
				$whereclause.=" AND";
			$whereclause.=" a.sn='$sni' or sn2='$sni'";
		}

		if (strlen($whereclause)!=0)
			$whereclause=" WHERE".$whereclause;
			
		
		if($distinct===true and $sni===null)
			$sql="SELECT distinct itemid,name,model,poref,title as potitle, vendor FROM ".SQL_TABLE_PREFIX.$this->appname[2]."_stock
			join ".SQL_TABLE_PREFIX.$this->appname[2]."_item on id=itemid
			join ".SQL_TABLE_PREFIX.$this->appname[2]."_po on poref=ref
			$whereclause order by name";
		else*/
		$sql="SELECT * FROM ".SQL_TABLE_PREFIX.$this->appname[2]."_stockview"; //print $sql;exit;
		$result=mysqli_query($sqllink,$sql);
		
		if ($result===false)
			return false;
		$stocks=Array();
		while ($pointer = mysqli_fetch_array($result))
		{
			//$stocka=Array();
			$stocks[]=Array("category"=>$pointer['category'],"brand"=>$pointer['brand'],"model"=>$pointer['model'],"sn"=>$pointer['sn'],"collectuser"=>$pointer['collectuser'],"collectdate"=>$pointer['collectdate'],"collectsiteid"=>$pointer['collectsiteid'],"collectsite"=>$pointer['collectsite']);
		}
		return $stocks;
	}
	
	
	public function listbrandsmodels($selection)
	{
		/*$selection
		0-> brand
		1-> model
		else-> model (do not use)
		*/
		global $sqllink;
		$results=Array();
		if($selection==0)
			$selection='brand';
		else
			$selection='model';
		$sql="SELECT distinct $selection FROM ".SQL_TABLE_PREFIX.$this->appname[2]."_stock order by $selection";
		$result=mysqli_query($sqllink,$sql);
		if ($result===FALSE)
			return false;
		while ($pointer = mysqli_fetch_array($result))
		{
			if ($pointer[$selection]=="")
				continue;
			$results[]=$pointer[$selection];
		}
		return $results;
	}

	public function insertstock($catid,$brandi,$modeli,$sni)
	{	/*return FALSE if failed; true if success*/
		/*only model can be empty string*/
		global $sqllink,$UserMgr,$ContentMgr;
		
		/*Check if already insert*/
		$sql="select * from ".SQL_TABLE_PREFIX.$this->appname[2]."_stockview where categoryid=$catid and brand='$brandi' and sn='$sni'";
		$result=mysqli_query($sqllink,$sql);
		if ($result===FALSE)
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Internal Error',"Failed to retrieve stock record. $sql SQL error:".mysqli_error($sqllink)));
			return false;
		}
			
		if(mysqli_num_rows($result)!=0)
		{
			$pointer = mysqli_fetch_array($result);
			$ContentMgr->append('content_main',$ContentMgr->dialog_box('Already collected',htmlspecialchars("Stock '$sni' already collected by ".$pointer['collectuser']." on ".$pointer['collectdate'])));
			mysqli_free_result($result);
			return false;
		}
		$sql="INSERT INTO ".SQL_TABLE_PREFIX.$this->appname[2]."_stock (categoryid,brand,model,sn,modifyuser) VALUES($catid,'$brandi','$modeli','$sni','".$UserMgr->userinfo['username']."')";
		$result=mysqli_query($sqllink,$sql);
		if ($result===FALSE)
		{					
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error','Failed to insert new stock record. SQL error:'.mysqli_error($sqllink)));
			return false;		
		}	
		else return true;
	}

	public function preparestocklist()
	{
		global $sqllink,$ContentMgr;
		$ContentMgr->set('title','ACDB :: '.$this->appname[1].' - Stock List');
		$ContentMgr->set('content_header','<h1>'.$this->appname[1].' - Stock List</h1>');
		$sites=$this->siteclass->listsites(TRUE);
		if ($sites===false)
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Internal Error','System cannot retrive site list'));
			return;
		}
		
		$ContentMgr->append('content_main','Please select Site for list:
		<form method="post" action="?app='.$this->appname[0].'&action=stocklist">
		<select name="siteid">
		<option value="NULL">Please select site</option>');
		foreach($sites as $siteid=>$site)
			$ContentMgr->append('content_main','<option value="'.$siteid.'">'.htmlspecialchars($site["name"]).'</option>');
		$ContentMgr->append('content_main','</select><input type="submit" name="subaction" value="List" /><input type="submit" name="subaction" value="Download" /></form>');
	}
	
	public function stocklist()
	{
		global $sqllink,$ContentMgr,$FileMgr,$AjaxMgr;
		$ContentMgr->set('title','ACDB :: '.$this->appname[1].' - Stock List');
		$ContentMgr->set('content_header','<h1>'.$this->appname[1].' - Stock List</h1>');
		/*add menu*/
		if(!isset($_GET['from']))
			$ContentMgr->append('menu','➜<li><a href="?app='.$this->appname[0].'&action=preparestocklist">Stock list</a></li>');
		
		if(!isset($_REQUEST['subaction']) or !isset($_REQUEST['siteid']))
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error','No proper values defined'));
			return;
		}
		/*Call ajax for sort table*/
		$AjaxMgr->loadlib('sorttable','');
		
		$listcriteria='';$fromparam='';
				
		if($_REQUEST['siteid']=='NULL')
			$siteidi=NULL;
		else
		{
			$siteidi=intval(trim($_REQUEST['siteid']));
			if($siteidi>0 or $siteidi=-1)/*-1 is warehouses*/
			{
				$sites=$this->siteclass->listsites(TRUE);
				if(strlen($listcriteria)!=0)
					$listcriteria.=", ";
				if ($siteidi==-1)
				{
					$warehouselist="";
					foreach ($sites as $site)
					{
						if($site["warehouse"]==1)
							$warehouselist.=$site["name"].", ";
					}
					if (strlen($warehouselist)>2)
						$warehouselist=substr($warehouselist, 0, -2);
					$listcriteria.=" Site: Warehouses ($warehouselist)";
				}
				else
					$listcriteria.=" Site:".$sites[$siteidi]["name"];
				$fromparam.="site";
			}else
			{/*invalid siteid*/
				$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error','No proper siteid defined'));
				return;	
			}
		}
		
		/*if(isset($_REQUEST['doid']))
		{
			$doid=intval(trim($_REQUEST['doid']));
			if($doid>0)
			{
				$this->doclass = new IMMINVENTORY_DO($this->userprivilage,$this->appname);
				$do=$this->doclass->getdo($doid,false);
				if(strlen($listcriteria)!=0)
					$listcriteria.=", ";
				$listcriteria.=" DO Date:".$do[$doid]['date'];
				$fromparam.="do";
			}else
			{//invalid doid
				$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error','No proper doid defined'));
				return;	
			}
		}*/
		///XXX
		$stocks=$this->getstocklist(FALSE,$itemidi,$siteidi,NULL);
		if ($stocks===false)
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Internal Error','System cannot retrive list of stocks. SQL error:'.mysqli_error($sqllink)));
			return;
		}
		if($_REQUEST['subaction']=="Download")
		{
			$tempfileLoc=dirname(__FILE__).'/../../services/filemgr/temp/'.$this->appname[0].'_'.md5(rand()).'.csv';
			$fp = fopen($tempfileLoc, "w");
			if($fp===false)
			{
				$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Internal Error','System cannot allocate disk space for file writing'));
				return;
			}
			fputcsv($fp,Array($this->appname[1]." Stock Report generated on ".date("Y-m-d H:i:s")));
			fputcsv($fp,Array("List Criteria - ".$listcriteria));
			fputcsv($fp,array_keys($stocks[0]));
			foreach($stocks as $stock)
			{
				if (isset($doid))
					if($stock['doid']!=$doid)
						continue;
				fputcsv($fp,$stock);
			}
			fclose($fp);
			$FileMgr->send_file($tempfileLoc,'stock'.date("Ymd_Hms").'.csv');
			unlink($tempfileLoc);
			exit();
		}elseif($_REQUEST['subaction']=="Download (by Model by Site)")
		{
			$tempfileLoc=dirname(__FILE__).'/../../services/filemgr/temp/'.$this->appname[0].'_'.md5(rand()).'.html';
			$fp = fopen($tempfileLoc, "w");
			if($fp===false)
			{
				$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Internal Error','System cannot allocate disk space for file writing'));
				return;
			}
			fwrite($fp, $this->appname[1]." Stock Report generated on ".date("Y-m-d H:i:s")."<br/>\n");
			fwrite($fp, "List Criteria - ".$listcriteria."<br/>\n");
			
			/*sort db results
			$poref  = array_column($stocks, 'poref');
			$itemname  = array_column($stocks, 'itemname');
			array_multisort($poref, SORT_ASC, $itemname, SORT_ASC, $stocks);*/
			
			$sites=$items=$counts=Array();
			//fputcsv($fp,array_keys($stocks[0]));
			foreach($stocks as $stock)
			{
				if (isset($doid))
					if($stock['doid']!=$doid)
						continue;
				//fputcsv($fp,$stock);
				$sites[$stock['collectsiteid']]=$stock['collectsite'];
				if(!isset($items[$stock['itemid']]))
					$items[$stock['itemid']]=Array('itemname'=>$stock['itemname'],'itemmodel'=>$stock['itemmodel'],'poref'=>$stock['poref'],'totalcount'=>1);
				else $items[$stock['itemid']]['totalcount']++;
				if(!isset($counts[$stock['siteid']][$stock['itemid']]))
					$counts[$stock['siteid']][$stock['itemid']]=1;
				else $counts[$stock['siteid']][$stock['itemid']]++;
			}
			
			/*sort array*/
			asort($sites);
			
			/*table headers*/
			fwrite($fp, '<table border="1"><tr>');
			$str="<th>Poref</th>";
			foreach ($items as $item)
				$str.="<th>".htmlspecialchars($item['poref'])."</th>";
			fwrite($fp, "$str</tr><tr>");
			
			$str="<th>Desc.</th>";
			foreach ($items as $item)
				$str.="<th>".htmlspecialchars($item['itemname'])."</th>";
			fwrite($fp, "$str</tr>");
			
			$str="<th>Item</th>";
			foreach ($items as $item)
				$str.="<th>".htmlspecialchars($item['itemmodel'])."</th>";
			fwrite($fp, "$str</tr><tr>");

			foreach ($sites as $siteid=>$site)
			{
				fwrite($fp, "<tr><th>".htmlspecialchars($site)."</th>");
				$str="";
				foreach ($items as $itemid=>$item)
				{
					if(isset($counts[$siteid][$itemid]))
						$str.="<td>".$counts[$siteid][$itemid]."</td>";
					else
						$str.="<td></td>";
				}
				fwrite($fp, "$str</tr>");
			}
			fwrite($fp, "<tr><td>Total</td>");
			$str="";
			foreach ($items as $itemid=>$item)
					$str.="<td>".$item['totalcount']."</td>";
			fwrite($fp, "$str</tr>");
			/*table data*/
			fwrite($fp, "</table>\n");
			fclose($fp);
			$FileMgr->send_file($tempfileLoc,'stock'.date("Ymd_Hms").'.html');
			unlink($tempfileLoc);
			exit();
		}
		{
			$ContentMgr->append('content_main',"<h4>List Criteria - $listcriteria</h4>");
			$ContentMgr->append('content_main','
			<form method="post" action="?app='.$this->appname[0].'&action=stocklist">
			<input type="hidden" name="siteid" value="'.htmlspecialchars($_REQUEST['siteid']).'" />
			<input type="hidden" name="itemid" value="'.htmlspecialchars($_REQUEST['itemid']).'" />');
			/*if (isset($doid))
				$ContentMgr->append('content_main','
				<input type="hidden" name="doid" value="'.$doid.'" />');*/
			$ContentMgr->append('content_main','
			<input type="submit" name="subaction" value="Download" />
			<input type="submit" name="subaction" value="Download (by Model by Site)" />
			</form>');
			$tablehtml='
			<table class="imminventory_stocktable sortable">
			<tr><th>Seq</th><th>Site</th><th>Category</th><th>Brand</th><th>SN</th><th>Collect date</th></tr>';
			$evenclass='';
			if(sizeof($stocks)==0)
				$tablehtml.='<tr><td colspan="6">No stock</td></tr>';
			else
			{
				$x=1;
				if(isset($_GET['from']))
					$fromparam.=$_GET['from'];
			}
			$itemgrouplist=Array();
			//$itemgroupcount=Array();
			foreach($stocks as $stock)
			{
				if(!isset($itemgrouplist[$stock['category']][$stock['brand']]))
				{
					$itemgrouplist[$stock['category']][$stock['brand']]=1;
				}
				else $itemgrouplist[$stock['category']][$stock['brand']]++;
				
				$tablehtml.="<tr$evenclass><th>$x</th><td><a href=\"?app=".$this->appname[0]."&action=stocklist&siteid=".$stock['collectsiteid']."&subaction=List&category=NULL\">".htmlspecialchars($stock['collectsite']).'</a></td>
				<td><a href="?app='.$this->appname[0].'&action=stocklist&siteid=NULL&subaction=List&category='.$stock['category'].'">'.htmlspecialchars($stock['category']).'</a></td>
				<td>'.htmlspecialchars($stock['brand']).'</td>
				<td>'.htmlspecialchars($stock['sn']).'</td><td>'.$stock['collectdate'].'</td></tr>';
				if($evenclass=='')
					$evenclass=' class="even"';
				else $evenclass='';
				$x++;
			}
			if(sizeof($itemgrouplist)!=0)
			{
				$ContentMgr->append('content_main','<table class="imminventory_stocktable sortable">
				<tr><th>Category</th><th>Brand</th><th>Qty</th></tr>');
				foreach ($itemgrouplist as $itemgroupcaterory=>$itemgroupbrands)
				{
					foreach ($itemgroupbrands as $itemgroupbrand=>$count)
					{
						$ContentMgr->append('content_main','<tr'.$evenclass.'><td>'.htmlspecialchars($itemgroupcaterory).'</td>
					<td>'.htmlspecialchars($itemgroupbrand).'</a></td>
					<td>'.$count.'</td></tr>');
					if($evenclass=='')
						$evenclass=' class="even"';
					else $evenclass='';
					}

				}
				$ContentMgr->append('content_main','</table>');
			}
			$ContentMgr->append('content_main',"<h4>Item list</h4>$tablehtml</table>");
			
			/*set menu (must be here as need to get $stock)*/
			if(isset($_GET['from']))
			{
				if($_GET['from']=="PO")
				{
					$ContentMgr->append('menu','➜<li><a href="?app='.$this->appname[0].'&action=newpo">PO</a></li>');
					$ContentMgr->append('menu','➜<li><a href="?app='.$this->appname[0].'&action=amendpo&poref='.urlencode($stock['poref']).'">'.$stock['poref'].'</a></li>');
				}
					
			}	
		}
	}
    
    public function preparesearchstock()
	{
		global $ContentMgr;
		$ContentMgr->set('title','ACDB :: '.$this->appname[1].' - Search Stock');
		$ContentMgr->set('content_header','<h1>'.$this->appname[1].' - Search Stock</h1>');
		$ContentMgr->append('content_main','Please enter keyword for searching the stock list:
		<form class="imminventory" method="post" action="?app='.$this->appname[0].'&action=searchstock">
		<input type="text" name="keyword" minlength="2" required />
		<input type="submit" name="subaction" value="Search" />
		');
	}
	
	public function searchstock()
	{
		global $sqllink,$ContentMgr;
		$ContentMgr->set('title','ACDB :: '.$this->appname[1].' - Search Stock');
		$ContentMgr->set('content_header','<h1>'.$this->appname[1].' - Search Stock</h1>');
		$ContentMgr->append('menu','➜<li><a href="?app='.$this->appname[0].'&action=preparesearchstock">Search Stock</a></li>');
		if(!isset($_REQUEST['keyword']))
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error',"Keyword cannot be empty"));
			return;
		}
		
		$keyword=trim($_REQUEST['keyword']);
		if(trim($keyword==''))
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error',"Keyword cannot be empty"));
			return;
		}
		$ContentMgr->append('content_main',"<h4>Search keyword - $keyword</h4>");
		$keywordi=mysqli_real_escape_string($sqllink,$keyword);
		$sql="SELECT g.name as sitename,model,a.sn,sn2,terminalid,hostname,utpname,switchname,switchport,INET_NTOA(ip) AS ip,bitlocketident,bitlockerkey,a.comments
			FROM ".SQL_TABLE_PREFIX.$this->appname[2]."_stock a
			join ".SQL_TABLE_PREFIX.$this->appname[2]."_item b on id=itemid
			join ".SQL_TABLE_PREFIX.$this->appname[2]."_po on b.poref=ref
			join ".SQL_TABLE_PREFIX.$this->appname[2]."_do d on d.id=a.doid
			left join (select * from ".SQL_TABLE_PREFIX.$this->appname[2]."_movement d where createdate=
			(select  max(createdate) from ".SQL_TABLE_PREFIX.$this->appname[2]."_movement e where e.sn=d.sn)) f on f.sn=a.sn
			left join ".SQL_TABLE_PREFIX.$this->appname[2]."_site g on g.id= f.site
		WHERE (a.sn LIKE '%$keywordi%' OR `sn2` LIKE '%$keywordi%' OR CAST(terminalid AS int) LIKE '%$keywordi%' OR `hostname` LIKE '%$keywordi%' OR `utpname` LIKE '%$keywordi%' OR `switchname` LIKE '%$keywordi%' OR CAST(switchport AS int) LIKE '%$keywordi%' OR INET_NTOA(ip) LIKE '%$keywordi%' OR `bitlocketident` LIKE '%$keywordi%' OR `bitlockerkey` LIKE '%$keywordi%' OR a.comments LIKE '%$keywordi%')";
		
		//$ContentMgr->append('content_main',$ContentMgr->dialog_box3('Anchor',$sql));
		$result=mysqli_query($sqllink,$sql);
		
		if ($result===false)
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box2('Error','Failed to execute search. SQL error:'.mysqli_error($sqllink)));
			return;
		}
		
		if(mysqli_num_rows($result)==0)
		{
			$ContentMgr->append('content_main',$ContentMgr->dialog_box('No result','How about trying another keyword?'));
			return;
		}

		$searchfields=Array("sn"=>"SN","sn2"=>"Alt. SN","terminalid"=>"Terminal ID","hostname"=>"Hostname","utpname"=>"	UTP name","switchname"=>"Switch name","switchport"=>"Switch port","ip"=>"IP","bitlocketident"=>"BitLocker Ident","bitlockerkey"=>"BitLocker Key","comments"=>"Comments");
		$hitfields=$resultsarray=Array();
		while ($pointer = mysqli_fetch_array($result))
		{
			$hitvalue='';
			$snr=$pointer['sn'];
			/*convert htmlspecialchars*/
			foreach ($pointer as $key=>$value)
				$pointer[$key]=htmlspecialchars($value);
			
			foreach ($searchfields as $searchfield => $fieldname)
			{
				$keypos=stripos($pointer[$searchfield],$keyword);
				if($keypos!==false)
				{
					if($hitvalue!='')
						$hitvalue.=', ';
					$hitvalue.=$fieldname;
					//$ContentMgr->append('content_main',"$fieldname in ".$pointer['sn']."<br />");
					if($searchfield!="sn")
						$hitfields[]=$searchfield;
					$pointer[$searchfield]=substr($pointer[$searchfield],0,$keypos).'<strong>'.substr($pointer[$searchfield],$keypos,strlen($keyword)).'</strong>'.substr($pointer[$searchfield],$keypos+strlen($keyword));
				}
			}
			$pointer["snr"]=$snr;
			$pointer["hitvalue"]=$hitvalue;
			$resultsarray[]=$pointer;
		}
		$hitfields=array_unique($hitfields);
		$hitfieldsth='';
		foreach ($hitfields as $hitfield)
		{
			$hitfieldsth.='<th>'.$searchfields[$hitfield].'</th>';
		}
		
		$evenclass='';
		$ContentMgr->append('content_main','<table class="imminventory_stocktable">
		<tr><th>Hit value</th><th>Site</th><th>Model</th><th>SN</th>'.$hitfieldsth.'</tr>
		');
		$ahrefsufffix='</a>';
		foreach ($resultsarray as $result)
		{
			$hitfieldstd='';
			if($evenclass=='')
				$evenclass=' class="even"';
			else $evenclass='';

			$ahrefprefix='<a href="?app='.$this->appname[0].'&action=editstock&from=searchstock+'.urlencode($keyword).'&sn='.urlencode($result['snr']).'">';

			foreach ($hitfields as $hitfield)
				$hitfieldstd.='<td>'.$result[$hitfield].'</td>';
			$ContentMgr->append('content_main',"
			<tr$evenclass><td>".$result['hitvalue'].'</td><td>'.$result['sitename'].'</td><td>'.$result['model']."</td><td>$ahrefprefix".$result['sn']."$ahrefsufffix</td>$hitfieldstd</tr>");
		}
		$ContentMgr->append('content_main','</table>');
	}
}